require 'studio_game/beserk_player'

module StudioGame
  describe BeserkPlayer do

    before do
      @initial_health = 50
      @beserker = BeserkPlayer.new("beserker", @initial_health)
      $stdout = StringIO.new
    end

    it "does not go beserk when w00ted up to five times" do
      1.upto(5) {@beserker.w00t}

      expect(@beserker.beserk?).to be_falsey
    end

    it "goes beserk when w00t more than five times" do
      1.upto(6) {@beserker.w00t}

      expect(@beserker.beserk?).to be_truthy
    end

    it "gets w00ted instead of blammed when it's beserk" do
      1.upto(6) {@beserker.w00t}
      1.upto(2) {@beserker.blam}

      expect(@beserker.health).to eq(@initial_health + 8 * 15)
    end
  end
end
