require 'studio_game/clumsy_player'

module StudioGame
  describe ClumsyPlayer do

    before do
      $stdout = StringIO.new
      @clumsy_player = ClumsyPlayer.new("klutz", 105)
    end

    it "damages a treasure receiving half of the points" do
      expect(@clumsy_player.points).to eq(0)

      @clumsy_player.found_treasure(Treasure.new(:hammer, 50))
      @clumsy_player.found_treasure(Treasure.new(:hammer, 50))
      @clumsy_player.found_treasure(Treasure.new(:hammer, 50))

      expect(@clumsy_player.points).to eq(75)

      @clumsy_player.found_treasure(Treasure.new(:crowbar, 400))
      @clumsy_player.found_treasure(Treasure.new(:skillet, 100))
      @clumsy_player.found_treasure(Treasure.new(:crowbar, 400))

      expect(@clumsy_player.points).to eq(525)

      yielded = []
      @clumsy_player.each_found_treasure do |treasure|
        yielded << treasure
      end

      expect(yielded).to eq([
                             Treasure.new(:hammer, 75),
                             Treasure.new(:crowbar, 400),
                             Treasure.new(:skillet, 50)
                            ])
    end

    context "with a boost factor" do

      before do
        @initial_health = 105
        @boost_factor = 5
        @clumsy = ClumsyPlayer.new("klutz", @initial_health, @boost_factor)
      end

      it "has a boost factor" do
        expect(@clumsy.boost_factor).to eq(5)
      end

      it "is w00ted up to the boost factor" do
        @clumsy.w00t

        expect(@clumsy.health).to eq(@initial_health + (@boost_factor * 15))
      end
    end

  end
end
